# Generated by Django 3.2.14 on 2022-07-09 22:10

import django.core.serializers.json
from django.db import migrations, models
import django.db.models.deletion
import nautobot.extras.models.mixins
import taggit.managers
import uuid


class Migration(migrations.Migration):

    dependencies = [
        ("extras", "0033_add__optimized_indexing"),
        ("dcim", "0009_add_natural_indexing"),
        ("nautobot_firewall_models", "0004_add_description"),
    ]

    operations = [
        migrations.CreateModel(
            name="CapircaPolicy",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4, editable=False, primary_key=True, serialize=False, unique=True
                    ),
                ),
                ("created", models.DateField(auto_now_add=True, null=True)),
                ("last_updated", models.DateTimeField(auto_now=True, null=True)),
                (
                    "_custom_field_data",
                    models.JSONField(blank=True, default=dict, encoder=django.core.serializers.json.DjangoJSONEncoder),
                ),
                ("pol", models.TextField(blank=True, null=True)),
                ("net", models.TextField(blank=True, null=True)),
                ("svc", models.TextField(blank=True, null=True)),
                ("cfg", models.TextField(blank=True, null=True)),
                (
                    "device",
                    models.OneToOneField(
                        blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to="dcim.device"
                    ),
                ),
                ("tags", taggit.managers.TaggableManager(through="extras.TaggedItem", to="extras.Tag")),
            ],
            options={
                "verbose_name_plural": "Capirca Policies",
                "ordering": ["device"],
            },
            bases=(models.Model, nautobot.extras.models.mixins.DynamicGroupMixin),
        ),
    ]
